Module Connector

  Dim myConnection As Net.Sockets.TcpClient
  Dim myStrm As Net.Sockets.NetworkStream
  Dim streamReader As Threading.Thread
  Public connected As Boolean = False
  Public onModule As Boolean = False

  Dim myId, chNum As Integer
  Dim myHost As String
  Dim myPort As Integer
  Dim ob As Object

  Public Sub initialize(ByRef host As Object)
    ob = host
  End Sub

  Public Sub connect(ByVal hostname As String, ByVal portnum As Integer)
    If (Not connected) Then
      Try
        myConnection = New Net.Sockets.TcpClient(hostname, portnum)
        myStrm = myConnection.GetStream()
        connected = True
        onModule = False
        myHost = hostname
        myPort = portnum
      Catch ex As Exception
        MsgBox("Connection refused. " & ex.Message)
        Return
      End Try
    Else
      MsgBox("Already connected.")
    End If
  End Sub
  Public Function whereis_lookup(ByVal lkup As String) As ArrayList
    Dim modules As New ArrayList
    Dim vo As ArrayList = New ArrayList
    Dim vi As ArrayList = New ArrayList

    vo.Add("where") '0
    vo.Add("command") '1

    vi.Add("mid")  '0
    vi.Add("name") '1

    Dim oxp As New SIMSA_XMLParser.XMLParser(vo)
    Dim ixp As New SIMSA_XMLParser.XMLParser(vi)

    'send whereis query
    writeOut(makeTag("whereis", makeTag("mtype", lkup)))

    Try
      While connected
        oxp.parse(ChrW(myStrm.ReadByte()))
        If (oxp.hasData) Then
          Dim data As String = oxp.getData
          Select Case oxp.getTagType
            Case 0 'where
              Dim mi As New ModInfo
              For Each c As Char In data.ToCharArray
                ixp.parse(c)
                If (ixp.hasData()) Then
                  Dim innerData = ixp.getData
                  Select Case ixp.getTagType
                    Case 0 'mid
                      mi.mid = ixp.getDataAsInt()
                    Case 1 'name
                      mi.name = ixp.getData()
                  End Select
                  ixp.reset()
                End If
              Next
              modules.Add(mi)
            Case 1 'command
              connected = False
          End Select
          oxp.reset()
        End If
      End While

      Return modules

    Catch ex As Exception
      MsgBox("Couldn't Load Module List. " & ex.Message)
      connected = False
      myConnection.Close()
    End Try
  End Function

  Public Sub connect_mod(ByVal myName As String, ByVal modId As Integer)
    If (Not connected) Then
      Try
        myConnection = New Net.Sockets.TcpClient(myHost, myPort)
        myStrm = myConnection.GetStream()
        connected = True
        onModule = False
      Catch ex As Exception
        MsgBox("Connection refused. " & ex.Message)
        Return
      End Try
    Else
      MsgBox("Already connected.")
    End If

    Dim vo As ArrayList = New ArrayList
    Dim vi As ArrayList = New ArrayList

    Dim conack As Boolean = False
    Dim isError As Boolean = False

    vo.Add("conack") '0
    vo.Add("error") '1

    vi.Add("id")  '0
    vi.Add("key") '1

    Dim oxp As New SIMSA_XMLParser.XMLParser(vo)
    Dim ixp As New SIMSA_XMLParser.XMLParser(vi)

    'send connect
    writeOut(makeTag("connect", makeTag("name", myName) & _
    makeTag("mid", modId)))

    Try
      While Not conack And Not isError
        oxp.parse(ChrW(myStrm.ReadByte()))
        If (oxp.hasData) Then
          Dim data As String = oxp.getData
          Select Case oxp.getTagType
            Case 0 'conack
              Dim mi As New ModInfo
              For Each c As Char In data.ToCharArray
                ixp.parse(c)
                If (ixp.hasData()) Then
                  Dim innerData = ixp.getData
                  Select Case ixp.getTagType
                    Case 0 'id
                      myId = ixp.getDataAsInt()
                    Case 1 'key
                      chNum = ixp.getDataAsInt()
                  End Select
                  ixp.reset()
                End If
              Next
              conack = True
            Case 1 'error
              isError = True
          End Select
          oxp.reset()
        End If
      End While

      If (conack) Then
        streamReader = New Threading.Thread(AddressOf reader)
        streamReader.Start()
        onModule = True
        connected = True
        Return
      End If

      If (isError) Then
        MsgBox("There was an error connecting.  Make sure your name is filled.")
        onModule = False
        connected = False
      End If

    Catch ex As Exception
      MsgBox("Couldn't connect to module. " & ex.Message)
      connected = False
      myConnection.Close()
    End Try
  End Sub

  'should be the ONLY user modified function... maybe create in client code and pass reference
  Private Sub reader()

    Dim coords As String()
    Dim game As SPong.Main = CType(ob, SPong.Main)
    Dim inData As String

    Dim vo As ArrayList = New ArrayList
    Dim vi As ArrayList = New ArrayList

    vo.Add("_msg")    '0
    vo.Add("command") '1

    vi.Add("d") '0 data
    vi.Add("s") '1 score

    Dim oxp As New SIMSA_XMLParser.XMLParser(vo)
    Dim ixp As New SIMSA_XMLParser.XMLParser(vi)

    Try
      While connected
        oxp.parse(ChrW(myStrm.ReadByte()))
        If (oxp.hasData) Then
          Dim data As String = oxp.getData
          Select Case oxp.getTagType
            Case 0 '_msg
              For Each c As Char In data.ToCharArray
                ixp.parse(c)
                If (ixp.hasData) Then
                  inData = ixp.getData
                  Select Case ixp.getTagType()
                    Case 0 'data
                      coords = inData.Split(",")
                      game.Ball.Left = Integer.Parse(coords(0))
                      game.Ball.Top() = Integer.Parse(coords(1))
                      game.Paddle1.Top = Integer.Parse(coords(2))
                      game.Paddle2.Top = Integer.Parse(coords(3))
                    Case 1 'score
                      coords = inData.Split(",")
                      game.scr1.Text = coords(0)
                      game.scr2.Text = coords(1)
                  End Select
                  ixp.reset()
                End If
              Next
            Case 1 'command
              connected = False
              onModule = False
          End Select
          oxp.reset()
        End If
      End While
    Catch ex As Exception
      MsgBox("Connection was lost. " & ex.Message)
      connected = False
      onModule = False
      myConnection.Close()
    End Try

    connected = False
    onModule = False
  End Sub

  Public Function makeTag(ByVal inStr As String, ByVal param As String) As String
    Dim temp As String = "<" & inStr & ">" & param & "</" & inStr & ">"
    Return temp
  End Function
  Public Sub sendMsg(ByVal message As String)
    If (connected) Then
      writeOut(makeTag("_msg", message))
    Else
      MsgBox("Please connect first.")
    End If
  End Sub
  Private Sub writeOut(ByVal inStr As String)
    If (connected) Then
      Try
        myStrm.Write(System.Text.Encoding.ASCII.GetBytes(inStr), 0, inStr.Length)
      Catch ex As Exception
        MsgBox("You are not connected. " & ex.Message)
      End Try
    End If
  End Sub

  Public Sub disconnect()
    If (connected) Then
      writeOut(makeTag("disconnect", makeTag("id", myId) & makeTag("key", chNum)))
    End If
    Try
      myStrm.Close()
      streamReader.Abort()
    Catch ex As Exception
      MsgBox("Closing Connection.")
    End Try
    connected = False
    onModule = False
  End Sub
End Module

Public Class ModInfo
  Public mid As Integer
  Public name As String

  Public Overrides Function toString() As String
    Return name
  End Function
End Class

