package simsa.module;

import java.net.Socket;

public abstract class Module implements Runnable {
  protected Socket connection;
  protected String modName;
  protected String connectedHost;
  protected int connectedPort;
  protected boolean running = true;
  
  abstract public void init();
  abstract public void run();
  abstract public void preTerminate();
   
  public final void connect(String host, int port) {
    try {
      init();
      connectedHost = host;
      connectedPort = port;
      connection = new Socket(host, port);
    } catch(Exception e) {
      System.err.println(e.getMessage());
    }
  }
  
  public final void terminate() {
    try {
      running = false;
      preTerminate();
      connection.close();
    } catch(Exception e) {
      System.err.println(e.getMessage());
    }
  }
}
