package Modules;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import simsa.module.Module;
import simsa.xml.XMLParser;

public class EchoLower extends Module {
  
  InputStream is;
  OutputStream os;
  XMLParser oxp, ixp;
  
  ArrayList<String> vo = new ArrayList<String>();
  ArrayList<String> vi = new ArrayList<String>();
  
  public void init() {
    //valid messages when not connected
    vo.add("_pkt");      //0
    vo.add("command");   //1
    vi.add("from");      //0
    vi.add("_msg");      //1
    
    oxp = new XMLParser(vo);
    ixp = new XMLParser(vi);
  }
  
  public void preTerminate() {
    System.out.println("Echo Lower is exiting...");
  }
  
  public void run() {
    String temp;
    
    try {
      connection.getOutputStream().write("<connect><mtype>Echo</mtype><name>Echo Lower</name></connect>".getBytes());
    } catch (Exception e) {
      running = false;
    }
    
    try {
      is = connection.getInputStream();
      os = connection.getOutputStream();
    } catch (Exception e) {
      System.out.println("Error opening streams...");
      running = false;
    }
    while(running) {
      try {
        oxp.parse((char)is.read());
        if(oxp.hasData()) {
          temp = oxp.getData();
          switch(oxp.getTagType()) {
            case 0: //_pkt
            {
              int tempFrom = 0;
              String tempMsg = "";
              for(char c : temp.toCharArray()) { //process inner tags
                ixp.parse(c);
                if(ixp.hasData()) {
                  switch(ixp.getTagType()) {
                    case 0: //from
                      tempFrom = ixp.getDataAsInt();
                      break;
                    case 1: //_msg
                      tempMsg = ixp.getData();
                      break;
                  }
                  ixp.reset();
                }
              }
              String outbound = "<_pkt><to>" + tempFrom + "</to><_msg>";
              outbound += tempMsg.toLowerCase() + "</_msg></_pkt>";
              os.write(outbound.getBytes());
            }
            break;
            case 1: //command
            {
              if(temp.equalsIgnoreCase("close"))
                terminate();
            }
            break;
          }
          oxp.reset();
        }
      } catch (Exception e) {
        terminate();
      }
    }
  }

  public static void main(String[] args) {
    try {
      EchoLower c = new EchoLower();
      c.connect(args[0].trim(), Integer.parseInt(args[1].trim()));
      Thread modRun = new Thread(c); //actually starts the module
      modRun.start();
    } catch (Exception e) {
      System.err.println("Module failed to load.");
    }
  }
}
