package Modules;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import simsa.module.Module;
import simsa.xml.XMLParser;

//THIS IS FOR ALL MODULES:
//There needs to be a way for the mods to
//clear their internal lists when clients
//disconnect.

public class Spong extends Module {
  
  public class Listener extends Thread {
    HashMap<Integer, BoardState> bs = new HashMap<Integer, BoardState>();
    boolean running;
    InputStream is;
    
    XMLParser oxp, ixp;
    ArrayList<String> vo = new ArrayList<String>();
    ArrayList<String> vi = new ArrayList<String>();
    
    Listener() {
      running = true;
      
      vo.add("_pkt");      //0
      vo.add("command");   //1
      vi.add("from");      //0
      vi.add("_msg");      //1
      
      oxp = new XMLParser(vo);
      ixp = new XMLParser(vi);
    }
    public void setInStrm(InputStream istr) {
      is = istr;
    }
    public void setRunning(boolean flag) {
      running = flag;
    }
    
    public void run() {
      String temp;
      BoardState curBoard;
      while(running) {
        try {
          oxp.parse((char)is.read());
          if(oxp.hasData()) {
            temp = oxp.getData();
            switch(oxp.getTagType()) {
              case 0: //_pkt
              {
                int frm = 0;
                String msg = "";
                for(char c : temp.toCharArray()) { //process inner tags
                  ixp.parse(c);
                  if(ixp.hasData()) {
                    switch(ixp.getTagType()) {
                      case 0: //from
                        frm = ixp.getDataAsInt();
                        break;
                      case 1: //_msg
                        msg = ixp.getData();
                        break;
                    }
                    ixp.reset();
                  }
                }
                synchronized(bs) {
                  if((curBoard = bs.get(frm)) != null) {
                    if(msg.equalsIgnoreCase("U"))
                      curBoard.movePaddleUp();
                    if(msg.equalsIgnoreCase("D"))
                      curBoard.movePaddleDown();
                    if(msg.equalsIgnoreCase("S"))
                      curBoard.movePaddleStop();
                  } else {
                    BoardState tmpBs = new BoardState(frm);
                    bs.put(frm, tmpBs);
                  }
                }
              }
              break;
              case 1: //command
              {
                if(temp.equalsIgnoreCase("close"))
                  terminate();
                running = false;
              }
              break;
            }
            oxp.reset();
          }
        } catch(Exception e) {
          running = false;
          System.out.println("Spong listener has died.");
        }
      }
    }
  };
  public class BoardState {
    //ball size = 20 x 20 px
    //paddles are 20 wide x 100 tall
    //court is 600 wide x 400 tall
    
    //paddles
    int p1pos;
    int p1vec;
    int p1vel;
    
    int p2pos;
    int p2vec;
    int p2vel;
    
    //ball
    int xpos;
    int ypos;
    int xvec;
    int yvec;
    int xvel;
    int yvel;
    int nx;
    int ny;
    
    //score
    int s1, s2;
    boolean updateScore;
    int ownerId;
    
    BoardState(int oid) {
      p1pos = 100;
      p1vec = 1;
      p1vel = 10;
      
      p2pos = 100;
      p2vec = 1;
      p2vel = 10;
      
      xpos = 300;
      ypos = 200;
      xvec = 1;
      yvec = 1;
      xvel = 15;
      yvel = 15;
      
      s1 = 0;
      s2 = 0;
      ownerId = oid;
      updateScore = false;
    }
    
    void calculatePosition() {
      //Calculate paddle positions
      p1pos += p1vec * p1vel;
      if(p1pos < 0) p1pos = 0;
      if(p1pos > 300) p1pos = 300;
      
      p2pos += p2vec * p2vel;
      if(p2pos < 0) p2pos = 0;
      if(p2pos > 300) p2pos = 300;
      
      //Calculate next move
      nx = xpos + xvel * xvec;
      ny = ypos + yvel * yvec;
      
      //Check ball bounds and update
      if(nx >= 580) {xvec = -1; s1++; updateScore = true;}
      if(nx <= 0) {xvec = 1; s2++; updateScore = true;}
      if(ny >= 380) {yvec = -1;}
      if(ny <= 0) {yvec = 1;}
      
      //paddle collision? The +10's everywhere are for centering the 20px ball
      if(ny + 10 >= p2pos && ny + 10 <= p2pos + 100) {
        if(nx >= 560) {
          xvec = -1;
          //the first number after int is the potential speed
          yvel = (int)(25.0 * (((ny + 10) - (p2pos + 50)) / 50.0));
          if(yvel < 0) {
            yvec = -1; //set reflection
            yvel = Math.abs(yvel);
          } else {
            yvec = 1;
          }
          ny = ypos + yvel * yvec;
        }
      }
      if(ny + 10 >= p1pos && ny + 10 <= p1pos + 100) {
        if(nx <= 20) {
          xvec = 1;
          //the first number after int is the potential speed
          yvel = (int)(25.0 * (((ny + 10) - (p1pos + 50)) / 50.0));
          if(yvel < 0) {
            yvec = -1; //set reflection
            yvel = Math.abs(yvel);
          } else {
            yvec = 1;
          }
          ny = ypos + yvel * yvec;
        }
      }
      
      //move ball
      xpos = nx;
      ypos = ny;
      
      //set paddle direction with ball's NEW move, AI-ish
      if(yvec > 0) {
        if(ypos + 10 + 20 > p2pos + 50) {
          p2vec = 1;
        } else {
          p2vec = 0;
        }
      } else {
        if(ypos + 10 - 20 < p2pos + 50) {
          p2vec = -1;
        } else {
          p2vec = 0;
        }
      }
    }
    void movePaddleUp() {
      p1vec = -1;
    }
    void movePaddleDown() {
      p1vec = 1;
    }
    void movePaddleStop() {
      p1vec = 0;
    }
    
    String getState() {
      return "<d>"+ xpos + "," + ypos + "," + p1pos + "," + p2pos + "</d>";
    }
    String getScore() {
      return "<s>" + s1 + "," + s2 + "</s>";
    }
  };
  
  final int MAX_SPEED = 8;
  //Listener l;
  Listener l;
  
  public void init() {
    l = new Listener();
  }
  
  public void run() {
    try {
      //start listener
      l.setInStrm(connection.getInputStream());
      l.start();
      
      connection.getOutputStream().write("<connect><mtype>Pong</mtype><name>Spong</name></connect>".getBytes());
    } catch (Exception e) {
      running = false;
    }
    
    StringBuilder outMsg;
    
    while (running) {
      try {
        outMsg = new StringBuilder();
        Thread.sleep(50);
        
        synchronized(l.bs) {
          for(BoardState tmpBs : l.bs.values()) {
            tmpBs.calculatePosition();
            outMsg.append("<_pkt><to>" + tmpBs.ownerId + "</to><_msg>");
            outMsg.append(tmpBs.getState());
            if(tmpBs.updateScore) {
              outMsg.append(tmpBs.getScore());
              tmpBs.updateScore = false;
            }
            outMsg.append("</_msg></_pkt>");
            connection.getOutputStream().write(outMsg.toString().getBytes());
          }
        }
        
      } catch (Exception e) {
        terminate();
      }
    }
  }
  
  public void preTerminate() {
    System.out.println("Spong is exiting...");
    l.setRunning(false);
  }
  
  public static void main(String[] args) {
    try {
      Spong c = new Spong();
      c.connect(args[0].trim(), Integer.parseInt(args[1].trim()));
      Thread modRun = new Thread(c); //actually starts the module
      modRun.start();
    } catch (Exception e) {
      System.err.println("Module failed to load.");
    }
  }
}